#!/usr/bin/env python
import time
import RPi.GPIO as GPIO
import pygame,sys
import math

#Vmtr002c_sR.py

# Bei Betrieb des A/D-Wandlers mit Vcc= +5V 
# unbedingt eine Reihenschaltung zweier 
# geeigneter Widerstaende zur Begrenzung der
# Ausgangsspannung an Pin 6 des ADC0831 
# auf ca. 3V vorsehen!   

#GPIO-Pins,die mit dem ADC0831_2 verbunden sind
AD_Dat  = 2 
AD_Clk = 4
AD_CS = 3   
#ReL2 zum Umschalten des Messbereichs
ReL2= 24
#Schalter zur Auswahl des Messbereichs
mb2=8

#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#ADC0831_2
GPIO.setup(AD_CS,GPIO.OUT)
GPIO.setup(AD_Dat,GPIO.IN)
GPIO.setup(AD_Clk,GPIO.OUT)
#ReL2
GPIO.setup(ReL2,GPIO.OUT)
#mb2
GPIO.setup(mb2,GPIO.IN)
#Anfangszustaende
out(AD_CS,hi)
out(ReL2,low)#Vorwiderstand Rv ein

def AD_einlesen():#ADC0831
	
    out(AD_Clk,low)
    AD_byte=0
    for n in range(8):  # ADW 8 mal einlesen
        time.sleep(0.001)        		
        #out(AD_CS,hi)
        Bit7=0x80
        time.sleep(0.001)
        out(AD_CS,low)
        time.sleep(0.001)
        Analogwert=0
        out(AD_Clk,hi)     # vgl. Darstellungen in den
        time.sleep(0.001)  #  Datenblaettern des ADC0831
        out(AD_Clk,low)
        time.sleep(0.001)
        out(AD_Clk,hi)
        time.sleep(0.001)
        out(AD_Clk,low)
        time.sleep(0.001)
        for z in range(8):#  8 Bit an AD_Dat einlesen
            if (inp(AD_Dat)):
                Analogwert=Analogwert|Bit7 
            out(AD_Clk,hi)
            time.sleep(0.002)
            out(AD_Clk,low)	 
            Bit7=Bit7>>1   # 1 Bit nach rechts schieben
            time.sleep(0.002)
            Ergebnis=Analogwert
        out(AD_CS,hi)    
        AD_byte=AD_byte+Analogwert
    AD_byte=AD_byte/8
    
    AD_Ergebnis=AD_byte    
    return AD_Ergebnis
     
                                # Spannungsanzeige abhaengig von Spannung
                                # am 5V-Pin des Raspberry Pi 
                                # "Eichen" des "Spannungsmessers"
                                # mithilfe einer Vergleichsmessung
                                # z. B. mit einem Digitalmultimeter moeglich
                                # Dazu Wert 1960 in 5er- oder 10er-Schritten
                                # verkleinern, bis Anzeige etwa
                                # der Anzeige des Multimeters entspricht   
def Umrechnungen(ADWert):       # wegen Spannung in V =AD_Ergebnis*5V/255
    Spg_wert=ADWert             # 5/255 = 0.019607843 
    Spg_wert=Spg_wert*1960 # z. B. ADWert=127 --> Spg_wert=127*1960=248920  
    Spg_wert=Spg_wert/1000 # 248
    Darstellungswert=Spg_wert/2 # 124 fuer die Zeigerdarstellung 
    if(inp(mb2)==1):
        Spg_wert=Spg_wert*2      
    Ziffer_eins=Spg_wert/100    # 2
    rest_z=Spg_wert % 100       # 48
    Ziffer_zwei=rest_z/10            # 4
    Ziffer_drei=rest_z%10            # 8
    return Ziffer_eins, Ziffer_zwei, Ziffer_drei, Darstellungswert,Spg_wert
    

#Farbendefintionen, kann auf andere Farben erweitert werden

schwarz=(  0,   0,   0)
weiss = (255, 255, 255)
blau =  (  0,   0, 255)
h_blau=(192,255,255)
gruen = (  0, 255,   0)
m_gruen=(0,192,0)
d_gruen=(0,128,0)
rot =   (255,   0,   0)
d_rot=(192,0,0)
gelb=(255,255,0)
d_gelb=(192,192,0)
magenta=(255,0,255)
cyan=(0,255,255)
orange=(255,128,64)
d_orange=(192,64,0)
braun=(128,64,0)
lila=(128,0,255)
grau=(192,192,192)
d_grau=(128,128,128)


def Beschriftung5V():
    out(ReL2,hi)
    #Beschriftungen "0, 1, 2, 3, 4, 5" an der Skala des simulierten Messgeraets
    #Schriftart=pygame.font.Font.set_bold  #fett
    Schriftart=pygame.font.SysFont("ARIAL",int(20*dis_f))     
    Label_w=Schriftart.render("0",1,VordGr_F)
    Bereich.blit(Label_w,(int((55)*dis_f),int(258*dis_f)))
    #Zuerst eventuell bereits vorhandene Zeichen 2, 4, 6, 8 und 10 Loeschen,
    pygame.draw.rect(Bereich,HintGr_F,(int(60*dis_f),int(195*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(94*dis_f),int(130*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(137*dis_f),int(88*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(195*dis_f),int(63*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(258*dis_f),int(50*dis_f),int(30*dis_f),int(20*dis_f)))     
        
    #dann 1, 2, 3, 4 und 5 darstellen
    Label_w=Schriftart.render("1",1,VordGr_F)
    Bereich.blit(Label_w,(int((68)*dis_f),int(193*dis_f)))
    Label_w=Schriftart.render("2",1,VordGr_F)
    Bereich.blit(Label_w,(int((98)*dis_f),int(129*dis_f)))
    Label_w=Schriftart.render("3",1,VordGr_F)
    Bereich.blit(Label_w,(int((145)*dis_f),int(87*dis_f)))
    Label_w=Schriftart.render("4",1,VordGr_F)
    Bereich.blit(Label_w,(int((200)*dis_f),int(61*dis_f)))
    Label_w=Schriftart.render("5",1,VordGr_F)
    Bereich.blit(Label_w,(int((262)*dis_f),int(50*dis_f)))      
     
    
    

def Beschriftung10V():
    out(ReL2,low)
    #Beschriftungen "0, 2, 4, 6, 8, 10" an der Skala des simulierten Messgeraets
    #Schriftart=pygame.font.Font.set_bold  #fett
    Schriftart=pygame.font.SysFont("ARIAL",int(20*dis_f))     
    Label_w=Schriftart.render("0",1,VordGr_F)
    Bereich.blit(Label_w,(int((55)*dis_f),int(258*dis_f)))
    #Zuerst eventuell bereits vorhandene 1, 2, 3, 4 und 5 Loeschen,
    pygame.draw.rect(Bereich,HintGr_F,(int(60*dis_f),int(195*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(94*dis_f),int(130*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(137*dis_f),int(88*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(195*dis_f),int(63*dis_f),int(30*dis_f),int(20*dis_f)))     
    pygame.draw.rect(Bereich,HintGr_F,(int(258*dis_f),int(50*dis_f),int(30*dis_f),int(20*dis_f)))        
    #dann 2, 4, 6, 8 und 10 darstellen    
    Label_w=Schriftart.render("2",1,VordGr_F)
    Bereich.blit(Label_w,(int((68)*dis_f),int(193*dis_f)))
    Label_w=Schriftart.render("4",1,VordGr_F)
    Bereich.blit(Label_w,(int((98)*dis_f),int(129*dis_f)))
    Label_w=Schriftart.render("6",1,VordGr_F)
    Bereich.blit(Label_w,(int((145)*dis_f),int(87*dis_f)))
    Label_w=Schriftart.render("8",1,VordGr_F)
    Bereich.blit(Label_w,(int((200)*dis_f),int(61*dis_f)))
    Label_w=Schriftart.render("10",1,VordGr_F)
    Bereich.blit(Label_w,(int((262)*dis_f),int(50*dis_f))) 
    
        

def Messwerteinlesen():
    ADWert=AD_einlesen()
       
    Spg_wert_tmp=ADWert
       
    #Umrechnung(ADWert)
    Ziffer_eins,Ziffer_zwei,Ziffer_drei,Darstellungswert,Spg_wert=Umrechnungen(ADWert)    
    
    #Bereich des sich aendernden Anzeigewerts zuerst loeschen
                                  
    pygame.draw.rect(Bereich,HintGr_F,(int(100*dis_f),int(317*dis_f),int(160*dis_f),int(40*dis_f)))
    pygame.draw.rect(Bereich,VordGr_F,(int(100*dis_f),int(317*dis_f),int(160*dis_f),int(40*dis_f)),2)
    #dann aktuellen Wert darstellen
    Schriftart=pygame.font.Font.set_bold
    Schriftart=pygame.font.SysFont("COURIERNew",int(40*dis_f))
    #Digitalanzeige     
    Label=Schriftart.render(str(Ziffer_eins)+"."+str(Ziffer_zwei)+str(Ziffer_drei)+Einheitenzeichen,1,VordGr_F)
    #   
    Bereich.blit(Label,(int(110*dis_f),int(317*dis_f)))#
                    
    
    # Nun Zeigerdarstellung
        
    x1_zg=int(270*dis_f)  # Anfang des Zeigers
    y1_zg=int(270*dis_f)
    
    #zuerst Bereich loeschen
    pygame.draw.rect(Bereich,HintGr_F,(int(70*dis_f),int(90*dis_f),int(210*dis_f),int(200*dis_f)))
    
    Cosinus=math.cos(math.pi*Darstellungswert/int(1.38*360))
    Sinus=math.sin(math.pi*Darstellungswert/int(1.38*360))
    
    L_x=int(165*dis_f*Cosinus)#
    L_y=int(165*dis_f*Sinus)#
    
    if(inp(mb2)==0):
        Beschriftung5V()
    if(inp(mb2)==1):
        Beschriftung10V()       

    #neue Linie fuer Zeiger zeichnen   Anfang        Ende  
    
    pygame.draw.line(Bereich,ptr_col,(x1_zg,y1_zg),(x1_zg-L_x,y1_zg-L_y),3)   
   
   #Anfang des Zeigers
    pygame.draw.circle(Bereich,VordGr_F,(int(270*dis_f),int(270*dis_f)),int(dis_f*10))
   #Rahmen um Messwerk darstellen
    pygame.draw.rect(Bereich,VordGr_F,(int(40*dis_f),int(40*dis_f),int(275*dis_f),int(275*dis_f)),3)

    delta_y=20*math.sin(30*math.pi/360)
    delta_x=20*math.cos(30*math.pi/360)


    
   #Skala darstellen
    #kurze Skalenstriche zuerst zeichnen
    for k in range(21):
        Cosinus_s=math.cos(9*k*math.pi/360)#+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 175
        L_x_s=int(175*dis_f*Cosinus_s)
        Sinus_s=math.sin(9*k*math.pi/360)#+math.pi*27.5/180)
        L_y_s=int(175*dis_f*Sinus_s)
        Cosinus=math.cos(9*k*math.pi/360)#+math.pi*27.5/180)
    #Punkt auf Kreisbogen mit Radius 150
        L_x=int(150*dis_f*Cosinus)
        Sinus=math.sin(9*k*math.pi/360)#+math.pi*27.5/180)
        L_y=int(150*dis_f*Sinus)
        #zuerst loeschen, also Linie mit Hintergrundfarbe zeichnen
        pygame.draw.line(Bereich,HintGr_F,(x1_zg-L_x_s,y1_zg-L_y_s),(x1_zg-L_x,y1_zg-L_y),1)
        #dann darstellen, nun Linie mit Vordergrundfarbe zeichnen
        pygame.draw.line(Bereich,VordGr_F,(x1_zg-L_x_s,y1_zg-L_y_s),(x1_zg-L_x,y1_zg-L_y),1) 
    #Nun lange Skalenstriche darstellen
    for k in range(6):
        Cosinus_s=math.cos(36*k*math.pi/360)
    #Punkt auf Kreisbogen mit Radius 185    
        L_x_s=int(185*dis_f*Cosinus_s)
        Sinus_s=math.sin(36*k*math.pi/360)
        L_y_s=int(185*dis_f*Sinus_s)
        Cosinus=math.cos(36*k*math.pi/360)
     #Punkt auf Kreisbogen mit Radius 150
        L_x=int(150*dis_f*Cosinus)
        Sinus=math.sin(36*k*math.pi/360)
        L_y=int(150*dis_f*Sinus)
                
        #dann darstellen, nun "Zeiger-Linie" mit Vordergrundfarbe zeichnen
        pygame.draw.line(Bereich,VordGr_F,(x1_zg-L_x_s,y1_zg-L_y_s),(x1_zg-L_x,y1_zg-L_y),3) 
    
                  
    pygame.display.update()


   

#Farben und Werte fuer Darstellung eingeben
print
print "*** Hintergrundfarbe ***"
print"schwarz,weiss,blau,h_blau,gruen,m_gruen"
print"d_gruen,rot,d_rot,gelb,d_gelb,magenta"
print"cyan,orange,d_orange,braun,lila,grau,d_grau"
HintGr_F = input("Hintergrundfarbe:")
print
print "*** Vordergrundfarbe ***"
print"schwarz,weiss,blau,h_blau,gruen,m_gruen"
print"d_gruen,rot,d_rot,gelb,d_gelb,magenta"
print"cyan,orange,d_orange,braun,lila,grau,d_grau"
print
VordGr_F = input("Vordergrundfarbe:")	
print "*** Zeigerfarbe ***"
print"schwarz,weiss,blau,h_blau,gruen,m_gruen"
print"d_gruen,rot,d_rot,gelb,d_gelb,magenta"
print"cyan,orange,d_orange,braun,lila,grau,d_grau"
ptr_col = input("Zeigerfarbe:")	
print
Caption_disp=raw_input("Bezeichnung: ")
print 
Einheitenzeichen=raw_input("Einheitenzeichen: ")
print
#Festlegungen: Width:500,Height:380"
dis_f=input("Darstellungsfaktor: ")#Faktor fuer Groesse der Darstellung
print
pygame.init()
Bereich =pygame.display.set_mode((int(360*dis_f),int(360*dis_f)))
Bereich.fill(HintGr_F)
pygame.display.set_caption(Caption_disp)

AD_einlesen()


while True:
    
    Messwerteinlesen()	
 
    
GPIO.Cleanup()	

